SystemOrganization addCategory: #QuantumLogic!
SystemOrganization addCategory: 'QuantumLogic-Engine'!
SystemOrganization addCategory: 'QuantumLogic-Example'!
SystemOrganization addCategory: 'QuantumLogic-Maze'!
SystemOrganization addCategory: 'QuantumLogic-Maze-Test'!
SystemOrganization addCategory: 'QuantumLogic-Tests'!

Error subclass: #OutOfQuantumPossibility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic'!

TestCase subclass: #QBaseballTest
	instanceVariableNames: 'b'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Maze-Test'!

!QBaseballTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/2/2014 17:10'!
setUp
	super setUp.
	b := QuantumBaseball new.
	b judge: (BaseBallJudge answer: #(9 4 7 6)).
! !

!QBaseballTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/2/2014 17:11'!
testRun
	b run.
	self assert: b conclusion equals: #(9 4 7 6)! !

!QBaseballTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/2/2014 17:16'!
testStep
	self assert: b sizeOfPossibilities equals: 3024.
	self assert: b step.
	self assert: b sizeOfPossibilities equals: 720.
	self assert: b step.
	self assert: b sizeOfPossibilities equals: 218.
	self assert: b step.
	self assert: b sizeOfPossibilities equals: 40.
	self assert: b step.
	self assert: b sizeOfPossibilities equals: 5.
	self assert: b step.
	self assert: b sizeOfPossibilities equals: 1.
	self deny: b step.! !

TestCase subclass: #QCreateEmptyMazeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Maze-Test'!

!QCreateEmptyMazeTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 11:14'!
testMaze1x2
| m |
m := QMaze new.
m createEmptyCellsRowSize: 1 columnSize: 2.
self assert: ((m cellAtRow: 1 atColumn: 1) canGoNorth: false south: false west: false east: true).
self assert: ((m cellAtRow: 1 atColumn: 2) canGoNorth: false south: false west: true east: false).
! !

!QCreateEmptyMazeTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 11:19'!
testMaze1x3
| m |
m := QMaze new.
m createEmptyCellsRowSize: 1 columnSize: 3.
self assert: ((m cellAtRow: 1 atColumn: 1) canGoNorth: false south: false west: false east: true).
self assert: ((m cellAtRow: 1 atColumn: 2) canGoNorth: false south: false west: true east: true).
self assert: ((m cellAtRow: 1 atColumn: 3) canGoNorth: false south: false west: true east: false).
! !

!QCreateEmptyMazeTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 11:21'!
testMaze2x1
| m |
m := QMaze new.
m createEmptyCellsRowSize: 2 columnSize: 1.
self assert: ((m cellAtRow: 1 atColumn: 1) canGoNorth: false south: true west: false east: false).
self assert: ((m cellAtRow: 2 atColumn: 1) canGoNorth: true south: false west: false east: false).
! !

TestCase subclass: #QMazePlacingWallTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Maze-Test'!

!QMazePlacingWallTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 11:23'!
testMaze1x2
| m |
m := QMaze new.
m createEmptyCellsRowSize: 1 columnSize: 2.
m placeVerticalWallToEastAtRowIndex: 1 atCellColumnIndex: 1.
self assert: ((m cellAtRow: 1 atColumn: 1) canGoNorth: false south: false west: false east: false).
self assert: ((m cellAtRow: 1 atColumn: 2) canGoNorth: false south: false west: false east: false).! !

!QMazePlacingWallTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 11:37'!
testMaze2x1
| m |
m := QMaze new.
m createEmptyCellsRowSize: 2 columnSize: 1.
m placeHorizontalWallToSouthAtRowIndex: 1 atCellColumnIndex: 1.

self assert: ((m cellAtRow: 1 atColumn: 1) canGoNorth: false south: false west: false east: false).
self assert: ((m cellAtRow: 2 atColumn: 1) canGoNorth: false south: false west: false east: false).! !

!QMazePlacingWallTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 11:37'!
testMaze2x2
| m |
m := QMaze new.
m createEmptyCellsRowSize: 2 columnSize: 2.
m placeVerticalWallToEastAtRowIndex: 1 atCellColumnIndex: 1.
m placeVerticalWallToEastAtRowIndex: 2 atCellColumnIndex: 1.
m placeHorizontalWallToSouthAtRowIndex: 1 atCellColumnIndex: 1.
m placeHorizontalWallToSouthAtRowIndex: 1 atCellColumnIndex: 2.

self assert: ((m cellAtRow: 1 atColumn: 1) canGoNorth: false south: false west: false east: false).
self assert: ((m cellAtRow: 2 atColumn: 1) canGoNorth: false south: false west: false east: false).
self assert: ((m cellAtRow: 1 atColumn: 2) canGoNorth: false south: false west: false east: false).
self assert: ((m cellAtRow: 2 atColumn: 2) canGoNorth: false south: false west: false east: false).! !

TestCase subclass: #QMazeReachGoalTest
	instanceVariableNames: 'maze'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Maze-Test'!

!QMazeReachGoalTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 18:37'!
setUp
	super setUp.
	maze := QMaze new.
	maze createEmptyCellsRowSize: 2 columnSize: 2.
	maze placeVerticalWallToEastAtRowIndex: 1 atCellColumnIndex: 1.
	maze placePlayerAtRowIndex: 1 atColumnIndex: 1.
	maze placeGoalAtRowIndex: 1 atColumnIndex: 2.! !

!QMazeReachGoalTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 18:54'!
testCannotGoThroughWallEast
maze movePlayerEast.
self deny: maze playerIsAtGoal! !

!QMazeReachGoalTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 18:57'!
testCannotGoThroughWallNorth
maze movePlayerNorth.
self assert: (maze playerIsAtRow: 1 atColumn: 1).! !

!QMazeReachGoalTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 18:58'!
testCannotGoThroughWallSouth
maze movePlayerSouth.
maze movePlayerSouth.
self assert: (maze playerIsAtRow: 2 atColumn: 1).! !

!QMazeReachGoalTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 18:55'!
testCannotGoThroughWallWest
maze movePlayerWest.
self assert: (maze playerIsAtRow: 1 atColumn: 1).! !

!QMazeReachGoalTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 18:44'!
testPlayerIsAtGoal
maze movePlayerSouth.
maze movePlayerEast.
maze movePlayerNorth.
self assert: maze playerIsAtGoal! !

!QMazeReachGoalTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 18:41'!
testSetUp

self assert: (maze playerIsAtRow: 1 atColumn: 1).
self assert: (maze goalIsAtRow: 1 atColumn: 2).
self deny: maze playerIsAtGoal! !

TestCase subclass: #QuantumArrayTest
	instanceVariableNames: 'qa'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Tests'!

!QuantumArrayTest methodsFor: 'as yet unclassified' stamp: 'hjo 3/1/2012 12:24'!
testExample

|e a|
a := QuantumArray new: 3.

a at: 1 possibilities: (1 to: 9).  
a at: 2 possibilities: (10 to: 12).  
a at: 3 possibilities: (50 to: 51).  

a indexOfUndetermined.
a possibilities.

a assertions: {[:array| 
		(array sum rem: 3) = 0
	]}.

e := DepthFirstQuantumEngine new.
e stack push: a.
e step.
e run.
self assert: 18 equals: e answers size.! !

TestCase subclass: #QuantumMapColoringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Tests'!

!QuantumMapColoringTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/15/2012 23:09'!
testJust

|colors seed engine|
colors := #(red green blue).

seed := QuantumMapColoring new.
seed alabama: (QuantumObject possibilities: colors).
seed florida: (QuantumObject possibilities: colors).
seed georgia: (QuantumObject possibilities: colors).
seed mississippi: (QuantumObject possibilities: colors).
seed tennessee: (QuantumObject possibilities: colors).

seed possibilities.


engine := DepthFirstQuantumEngine new.
engine stack push: seed.
engine run.

self assert: 6 equals: engine answers size.! !

TestCase subclass: #QuantumNonogramTest
	instanceVariableNames: 'nono'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Tests'!

!QuantumNonogramTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2012 18:26'!
setUp 

	super setUp.
	nono := QuantumNonogram rows: 6 columns: 6.
	nono createRowAt: 1 withHint: {2. 1}.
	nono createRowAt: 2 withHint: {1. 3}.
	nono createRowAt: 3 withHint: {1. 2}.
	nono createRowAt: 4 withHint: {3}.
	nono createRowAt: 5 withHint: {4}.
	nono createRowAt: 6 withHint: {1}.

	nono createColumnAt: 1 withHint: {1}.
	nono createColumnAt: 2 withHint: {5}.
	nono createColumnAt: 3 withHint: {2}.
	nono createColumnAt: 4 withHint: {5}.
	nono createColumnAt: 5 withHint: {2. 1}.
	nono createColumnAt: 6 withHint: {2}.! !

!QuantumNonogramTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2012 21:35'!
testArray

	| seed engine ans |
	seed := QuantumNonogramArray cells: {QuantumObject possibilities:{true. false}. QuantumObject possibilities:{true. false}} hints: {2}.

	engine := DepthFirstQuantumEngine new.
	engine stack push: seed.
	engine run.
	ans := engine answers.
	
	self assert: 1 equals: ans size.
	self assert: true equals: (ans anyOne cells at: 1) determinedValue.
	self assert: true equals: (ans anyOne cells at: 2) determinedValue.! !

!QuantumNonogramTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2012 20:42'!
testMain

	nono runSolving.
	self assert: 
'a QuantumNonogram
1 1 0 0 0 1 
0 1 0 1 1 1 
0 1 0 1 1 0 
0 1 1 1 0 0 
0 1 1 1 1 0 
0 0 0 1 0 0 '
	 equals:  nono printString.! !

TestCase subclass: #QuantumObjectTest
	instanceVariableNames: 'only three'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Tests'!

!QuantumObjectTest methodsFor: 'running' stamp: 'hjo 2/1/2012 14:01'!
setUp

	super setUp.
	three := QuantumObject possibilities: {1. 2. 3}.
	only := QuantumObject possibilities: {4}.! !

!QuantumObjectTest methodsFor: 'tests' stamp: 'hjo 2/1/2012 14:01'!
testBe

	self assert: 3 equals: three possibilities size.
	three be: 2.
	self assert: 1 equals: three possibilities size.
	self flag: 'error when object is not in possibility'.! !

!QuantumObjectTest methodsFor: 'tests' stamp: 'hjo 2/1/2012 14:05'!
testBeNotInThePossibilities

	self should: [three be: 200] raise: AssertionFailure.! !

!QuantumObjectTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2012 18:23'!
testDeterminedValue

	self assert: 4 equals: only determinedValue.
	self should:  [three determinedValue ] raise: AssertionFailure.
	  ! !

!QuantumObjectTest methodsFor: 'tests' stamp: 'hjo 2/1/2012 14:01'!
testIsDetermined

	self deny: three isDetermined.
	self assert: only isDetermined.! !

!QuantumObjectTest methodsFor: 'tests' stamp: 'hjo 2/1/2012 13:54'!
testPossibilities

	self should: [QuantumObject possibilities: {}  ] raise: AssertionFailure ! !

!QuantumObjectTest methodsFor: 'tests' stamp: 'hjo 2/1/2012 14:01'!
testRemovePossibility

	three removePossibility: 3.  
	self assert: 2 equals: three possibilities size.
	self should:  [only removePossibility: 4] raise: OutOfQuantumPossibility.
	  ! !

TestCase subclass: #QuantumSudokuTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Tests'!

!QuantumSudokuTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/15/2012 23:15'!
testOne
|sudoku dfa|
sudoku := 
QuantumSudoku matrix: ((Matrix rows: 9 columns: 9 contents:	
		#(
			1  8  6  nil  nil  nil    9  2  nil
			nil    5  nil    9  nil    6  nil  nil  8
			4  nil  nil  nil  nil  nil  nil  nil  nil
			8  nil  nil  2  nil  nil    4    5  7
			nil  nil    7  nil    4  nil  nil  nil    1
			nil  nil    4  nil  nil    8  nil  nil    3
			2  nil    8    1  nil    9  nil    7    4
			nil  nil  nil  nil  nil  nil  nil    1  nil
			nil    9    1    5    2    4    8  nil  nil
			))
		collect: [:v  |
			QuantumObject possibilities:  (v isNil ifTrue: [ (1 to: 9) ] ifFalse: [{v} ]).
			]).

dfa := DepthFirstQuantumEngine new.
dfa stack push: sudoku.
dfa run.
dfa answers. 
! !

TestCase subclass: #QuantumTapeTest
	instanceVariableNames: 'qa'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Tests'!

!QuantumTapeTest methodsFor: 'as yet unclassified' stamp: 'hjo 3/1/2012 09:27'!
setUp

	super setUp.
	qa := QuantumTape new.! !

!QuantumTapeTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/25/2012 12:22'!
testAddLast

	" (*) (hello *) (hello world *) (hello world quantum *)"
	qa defaultElement: (QuantumObject possibilities: {'hello'. 'quantum'. 'world'}).
	
	self assert: '(*)' equals: qa printString.
	
	qa addLast be: 'hello'.
	self assert: '(''hello'' *)' equals: qa printString.
	
	qa addLast be: 'world'.
	self assert: '(''hello'' ''world'' *)' equals: qa printString.
	
	qa addLast be: 'quantum'.
	self assert: '(''hello'' ''world'' ''quantum'' *)' equals: qa printString.! !

!QuantumTapeTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/25/2012 10:47'!
testAtBe

	" (*) (hello *) (hello ? ? world *) "
	qa defaultElement: (QuantumObject possibilities: {'hello'. 'quantum'. 'world'}).
	
	qa at: 1 be: 'hello'.
	self assert: 'hello' equals: (qa at: 1) determinedValue.
	
	qa at: 4 be: 'world'.
	self assert: 'world' equals: (qa at: 4) determinedValue.
	self deny: (qa at: 2) isDetermined.
	self deny: (qa at: 3) isDetermined.! !

!QuantumTapeTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/25/2012 10:47'!
testOnceSizeIsFixedNoMoreAddingElements

	" ... fixSzie at: put: bigIndex ==> error "
	qa defaultElement: (QuantumObject possibilities: (1to:3)).	
	qa at: 1 be: 2.
	qa fixSize.
	self should: [qa at: 2 be: 3] raise: Error.! !

!QuantumTapeTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/25/2012 10:47'!
testPrintOn

	" (*) (hello *) (hello ? ? world *) (hello ? ? world)"
	qa defaultElement: (QuantumObject possibilities: {'hello'. 'quantum'. 'world'}).
	
	self assert: '(*)' equals: qa printString.
	
	qa at: 1 be: 'hello'.
	self assert: '(''hello'' *)' equals: qa printString.
	
	qa at: 4 be: 'world'.
	self assert: '(''hello'' ? ? ''world'' *)' equals: qa printString.
	
	qa fixSize.
	self assert: '(''hello'' ? ? ''world'')' equals: qa printString.! !

!QuantumTapeTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/25/2012 10:47'!
testSize

	"size  ==>  #undeterminedSize or integer "
	qa defaultElement: (QuantumObject possibilities: (1to:3)).
	self assert: #undeterminedSize equals: qa size.
	
	qa at: 1 be: 2.
	self assert: #undeterminedSize equals: qa size.
		
	qa fixSize.
	self assert: 1 equals: qa size.! !

!QuantumTapeTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/25/2012 10:47'!
testStubElementsAreNotSharedObjects

	" not == "
	qa defaultElement: (QuantumObject possibilities: (1to:9)) .
	qa at: 4 be: 7.
	self deny: (qa at: 2)==(qa at: 3).
! !

Object subclass: #BaseBallJudge
	instanceVariableNames: 'answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Example'!

!BaseBallJudge class methodsFor: 'as yet unclassified' stamp: 'hjo 2/16/2012 08:31'!
answer: anArray 

	^self new answer: anArray! !

!BaseBallJudge methodsFor: 'as yet unclassified' stamp: 'hjo 2/25/2012 12:53'!
answer: anArray 

	answer := anArray! !

!BaseBallJudge methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 17:06'!
judge: anArray 

	|ment|
	ment := BaseBallJudgement new.
	ment submission: anArray.
	ment strikes: 0.
	ment balls: 0.
	
	1 to: 4 do: [:k|
		1 to: 4 do: [:t|
				(answer at: k) = (anArray at: t) ifTrue: 
					[ k = t 
					ifTrue: [ ment increaseStrikes ] 
					ifFalse: [ ment increaseBalls ].
					]	
			]
		].
	^ment! !

!BaseBallJudge methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/2/2014 19:37'!
verifyJudgement: aBaseBallJudgement 
	^(self judge: aBaseBallJudgement submission) = aBaseBallJudgement! !

Object subclass: #BaseBallJudgement
	uses: HashProofTrait
	instanceVariableNames: 'strikes balls submission'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Example'!

BaseBallJudgement class
	uses: HashProofTrait classTrait
	instanceVariableNames: ''!

!BaseBallJudgement class methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 17:02'!
submission: anArray strikes: int1 balls: int2

	^self new
		submission: anArray;
		strikes: int1;
		balls: int2	! !

!BaseBallJudgement methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 16:55'!
balls

	^balls! !

!BaseBallJudgement methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 16:47'!
balls: aSmallInteger 

	balls := aSmallInteger! !

!BaseBallJudgement methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 17:04'!
gettersForEquality

	^#(submission strikes balls)! !

!BaseBallJudgement methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 17:06'!
increaseBalls

	balls := balls + 1! !

!BaseBallJudgement methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 17:07'!
increaseStrikes

	strikes := strikes + 1! !

!BaseBallJudgement methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 17:05'!
initialize 

	super initialize.
	strikes := 0.
	balls := 0.! !

!BaseBallJudgement methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 16:55'!
strikes

	^strikes! !

!BaseBallJudgement methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 16:47'!
strikes: aSmallInteger 

	strikes := aSmallInteger! !

!BaseBallJudgement methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 17:03'!
submission

	^submission! !

!BaseBallJudgement methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 17:03'!
submission: anArray

	submission := anArray! !

Object subclass: #DepthFirstQuantumEngine
	instanceVariableNames: 'answers stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Engine'!

!DepthFirstQuantumEngine methodsFor: 'as yet unclassified' stamp: 'hjo 3/27/2008 11:02'!
addToAnswers: anObject

	self answers add: anObject! !

!DepthFirstQuantumEngine methodsFor: 'accessing' stamp: 'hjo 2/2/2008 23:13'!
answers

	answers isNil ifTrue: [answers := OrderedCollection new].
	^answers! !

!DepthFirstQuantumEngine methodsFor: 'looping' stamp: 'hjo 2/2/2008 23:15'!
run

	[self stack isEmpty]
		whileFalse: [ self step ]! !

!DepthFirstQuantumEngine methodsFor: 'looping' stamp: 'hjo 2/2/2008 21:48'!
runToFindOneAnswer

	[ self answers isEmpty ] whileTrue: [ self step ]! !

!DepthFirstQuantumEngine methodsFor: 'accessing' stamp: 'hjo 2/2/2008 23:12'!
stack

	stack isNil ifTrue: [stack := Stack new].
	^stack! !

!DepthFirstQuantumEngine methodsFor: 'accessing' stamp: 'hjo 1/28/2012 19:38'!
stackContents

	^String streamContents: [:stream| 
		self stack do: [:sl| sl printOn: stream. stream cr ]
	]! !

!DepthFirstQuantumEngine methodsFor: 'testing' stamp: 'hjo 2/2/2008 23:15'!
stackIsEmpty

	^self stack isEmpty! !

!DepthFirstQuantumEngine methodsFor: 'as yet unclassified' stamp: 'hjo 1/29/2012 17:47'!
stackPopPossibilities

	^self stack pop possibilities! !

!DepthFirstQuantumEngine methodsFor: 'accessing' stamp: 'hjo 2/2/2008 23:14'!
stackSize
	
	^self stack size! !

!DepthFirstQuantumEngine methodsFor: 'accessing' stamp: 'hjo 1/29/2012 17:50'!
stackTop

	^self stack first! !

!DepthFirstQuantumEngine methodsFor: 'looping' stamp: 'hjo 1/29/2012 17:47'!
step

	"override this for more control over processing agents"
	
	self stackPopPossibilities do: 
		[:agent| 
			agent isDetermined
				ifTrue: [self addToAnswers: agent]
				ifFalse: [self stack push: agent]
		]! !

DepthFirstQuantumEngine subclass: #MaxFindingDepthFirstQuantumEngine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Engine'!

!MaxFindingDepthFirstQuantumEngine methodsFor: 'as yet unclassified' stamp: 'hjo 3/27/2008 10:48'!
addToAnswers: anEcologicalBinPacking 

	self answers put: anEcologicalBinPacking! !

!MaxFindingDepthFirstQuantumEngine methodsFor: 'as yet unclassified' stamp: 'hjo 3/27/2008 10:17'!
answers

	answers isNil ifTrue: [ answers := MaxClub new ].
	^answers! !

!MaxFindingDepthFirstQuantumEngine methodsFor: 'as yet unclassified' stamp: 'hjo 3/27/2008 10:17'!
evaluator: aBlockContext

	self answers evaluator: aBlockContext! !

!MaxFindingDepthFirstQuantumEngine methodsFor: 'as yet unclassified' stamp: 'hjo 1/29/2012 17:47'!
stackPopPossibilities

	| spreaded |
	spreaded := super stackPopPossibilities.
	^self answers maximum isNil
		ifTrue: [spreaded]
		ifFalse: [spreaded select: [:each| self answers mayAccept: each ]]! !

Object subclass: #QBetweenCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Maze'!

QBetweenCell subclass: #QConnector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Maze'!

QConnector subclass: #QWall
	instanceVariableNames: 'westCell eastCell'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Maze'!

QWall subclass: #QHorizontalWall
	instanceVariableNames: 'northCell southCell'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Maze'!

!QHorizontalWall methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 10:59'!
northCell: aQCell 
northCell := aQCell ! !

!QHorizontalWall methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 10:59'!
southCell: aQCell 
southCell := aQCell! !

QWall subclass: #QVerticalWall
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Maze'!

!QWall methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/18/2012 15:31'!
canGoThrough
^false! !

!QWall methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/16/2012 01:03'!
eastCell: aQCell 
eastCell:= aQCell 
! !

!QWall methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/16/2012 01:03'!
westCell: aQCell 
westCell:= aQCell ! !

QConnector subclass: #QWay
	instanceVariableNames: 'cell1 cell2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Maze'!

QWay subclass: #QHorizontalWay
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Maze'!

!QHorizontalWay methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 09:38'!
northCell: aQCell 
cell1 := aQCell ! !

!QHorizontalWay methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 09:38'!
southCell: aQCell 
cell2 := aQCell ! !

QWay subclass: #QVerticalWay
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Maze'!

!QVerticalWay methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 09:38'!
eastCell: aQCell 
cell2 := aQCell ! !

!QVerticalWay methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 09:38'!
westCell: aQCell 
cell1 := aQCell ! !

!QWay methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/18/2012 18:22'!
canGoThrough
^true! !

QBetweenCell subclass: #QTerminal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Maze'!

!QTerminal methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 10:31'!
canGoThrough
^false! !

Object subclass: #QCell
	instanceVariableNames: 'northBetween southBetween eastBetween westBetween'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Maze'!

!QCell methodsFor: 'testing' stamp: 'HwaJong 10/18/2012 15:32'!
canGoEast
^eastBetween canGoThrough! !

!QCell methodsFor: 'testing' stamp: 'HwaJong 10/18/2012 15:31'!
canGoNorth
^northBetween canGoThrough ! !

!QCell methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 11:12'!
canGoNorth: bool1 south: bool2 west: bool3 east: bool4 

self canGoNorth = bool1 ifFalse: [^false].
self canGoSouth = bool2 ifFalse: [^false].
self canGoWest = bool3 ifFalse: [^false].
self canGoEast = bool4 ifFalse: [^false].
^true! !

!QCell methodsFor: 'testing' stamp: 'HwaJong 10/18/2012 15:32'!
canGoSouth
^southBetween canGoThrough! !

!QCell methodsFor: 'testing' stamp: 'HwaJong 10/18/2012 15:30'!
canGoWest
	^westBetween canGoThrough ! !

!QCell methodsFor: 'accessing' stamp: 'HwaJong 10/19/2012 00:40'!
northBetween: aQConnector
	northBetween := aQConnector! !

!QCell methodsFor: 'way' stamp: 'HwaJong 10/19/2012 09:37'!
placeHorizontalSouthWayBetween: aQCell 
	southBetween := QHorizontalWay new.
	southBetween northCell: self.
	southBetween southCell: aQCell.
	aQCell northBetween: southBetween.! !

!QCell methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 10:58'!
placeHorizontalWallToSouthBetween: aQCell 
|w|
w := QHorizontalWall new.
w northCell: self.
w southCell: aQCell.

southBetween := w.
aQCell northBetween: w.! !

!QCell methodsFor: 'terminal wall' stamp: 'HwaJong 10/19/2012 10:29'!
placeTerminalWallEast
	eastBetween := QVerticalWall new.! !

!QCell methodsFor: 'terminal wall' stamp: 'HwaJong 10/20/2012 18:51'!
placeTerminalWallNorth
	northBetween := QTerminal new.! !

!QCell methodsFor: 'terminal wall' stamp: 'HwaJong 10/20/2012 18:51'!
placeTerminalWallSouth
	southBetween := QTerminal new.! !

!QCell methodsFor: 'terminal wall' stamp: 'HwaJong 10/20/2012 18:51'!
placeTerminalWallWest
	westBetween := QTerminal new.! !

!QCell methodsFor: 'way' stamp: 'HwaJong 10/19/2012 09:37'!
placeVerticalEastWayBetween: aQCell 
	eastBetween := QVerticalWay new.
	eastBetween westCell: self.
	eastBetween eastCell: aQCell.
	aQCell westBetween: eastBetween.! !

!QCell methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 10:45'!
placeVerticalWallToEastBetween: aQCell 
|w|
w := QVerticalWall new.
w westCell: self.
w eastCell: aQCell.

eastBetween := w.
aQCell westBetween: w.
! !

!QCell methodsFor: 'accessing' stamp: 'HwaJong 10/16/2012 01:04'!
westBetween: aQWall 

	westBetween := aQWall! !

Object subclass: #QCellRowColumn
	uses: ClassCheckingHashProofTrait
	instanceVariableNames: 'rowIndex columnIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Maze'!

QCellRowColumn class
	uses: ClassCheckingHashProofTrait classTrait
	instanceVariableNames: ''!

!QCellRowColumn class methodsFor: 'instance creation' stamp: 'HwaJong 10/19/2012 17:02'!
rowIndex: rIndex columnIndex: cIndex 
^self new
	rowIndex: rIndex;
	columnIndex: cIndex! !

!QCellRowColumn methodsFor: 'accessing' stamp: 'HwaJong 10/19/2012 18:23'!
columnIndex
	^ columnIndex! !

!QCellRowColumn methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 17:09'!
columnIndex: anInteger 
columnIndex := anInteger ! !

!QCellRowColumn methodsFor: 'accessing' stamp: 'HwaJong 10/19/2012 18:53'!
getFromMatrix: aMatrix 
^aMatrix at: rowIndex at: columnIndex! !

!QCellRowColumn methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 18:37'!
gettersForEquality
^#(rowIndex columnIndex)! !

!QCellRowColumn methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 18:45'!
increaseRow: anInteger column: anInteger2 

rowIndex := anInteger + rowIndex.
columnIndex := anInteger2 + columnIndex.! !

!QCellRowColumn methodsFor: 'accessing' stamp: 'HwaJong 10/19/2012 18:23'!
rowIndex
	^ rowIndex! !

!QCellRowColumn methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2012 17:09'!
rowIndex: anInteger
rowIndex := anInteger! !

Object subclass: #QMaze
	instanceVariableNames: 'cellMatrix playerRowColumn goalRowColumn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Maze'!

!QMaze methodsFor: 'boundary cells' stamp: 'HwaJong 10/18/2012 21:50'!
bottomCells
	^cellMatrix atRow: cellMatrix rowCount.! !

!QMaze methodsFor: 'accessing cell' stamp: 'HwaJong 10/18/2012 15:29'!
cellAtRow: rowIndex atColumn: columnIndex 
^cellMatrix at: rowIndex at: columnIndex ! !

!QMaze methodsFor: 'build' stamp: 'HwaJong 10/19/2012 11:06'!
createEmptyCellsRowSize: rSize columnSize: cSize
cellMatrix := Matrix rows: rSize columns: cSize contents: (rSize * cSize instancesOf: QCell).

self topCells do: [:eachCell| eachCell placeTerminalWallNorth ].
self bottomCells do: [:eachCell| eachCell placeTerminalWallSouth ].
self leftCells do: [:eachCell| eachCell placeTerminalWallWest ].
self rightCells do: [:eachCell| eachCell placeTerminalWallEast ].

MultiDimensionalDo new
	domains: {1 to: cellMatrix rowCount . 1 to: cellMatrix columnCount -1};
	block: [:rIndex :cIndex|
		(cellMatrix at: rIndex at: cIndex) placeVerticalEastWayBetween: (cellMatrix at: rIndex at: cIndex+1).];
	run.

MultiDimensionalDo new
	domains: {1 to: cellMatrix columnCount  . 1 to: cellMatrix rowCount -1 };
	block: [:cIndex :rIndex|
		(cellMatrix at: rIndex at: cIndex) placeHorizontalSouthWayBetween: (cellMatrix at: rIndex+1 at: cIndex)];
	run.! !

!QMaze methodsFor: 'testing' stamp: 'HwaJong 10/19/2012 18:34'!
goalIsAtRow: anInteger atColumn: anInteger2 
^(QCellRowColumn rowIndex: anInteger columnIndex: anInteger2) = goalRowColumn.! !

!QMaze methodsFor: 'boundary cells' stamp: 'HwaJong 10/18/2012 21:49'!
leftCells
	^cellMatrix atColumn: 1! !

!QMaze methodsFor: 'player' stamp: 'HwaJong 10/20/2012 19:29'!
movePlayerEast
self playerCanGoEast
	ifTrue: [playerRowColumn increaseRow: 0 column: 1].! !

!QMaze methodsFor: 'player' stamp: 'HwaJong 10/20/2012 19:29'!
movePlayerNorth
self playerCanGoNorth
	ifTrue: [playerRowColumn increaseRow: -1 column: 0]! !

!QMaze methodsFor: 'player' stamp: 'HwaJong 10/20/2012 19:27'!
movePlayerSouth
self playerCanGoSouth
	ifTrue: [playerRowColumn increaseRow: 1 column: 0]! !

!QMaze methodsFor: 'player' stamp: 'HwaJong 10/20/2012 19:28'!
movePlayerWest
self playerCanGoWest
	ifTrue: [playerRowColumn increaseRow: 0 column: -1] ! !

!QMaze methodsFor: 'build' stamp: 'HwaJong 10/19/2012 18:34'!
placeGoalAtRowIndex: rIndex atColumnIndex: cIndex 
goalRowColumn := QCellRowColumn rowIndex: rIndex columnIndex: cIndex.! !

!QMaze methodsFor: 'build' stamp: 'HwaJong 10/19/2012 10:55'!
placeHorizontalWallToSouthAtRowIndex: rIndex atCellColumnIndex: cIndex 
| cell1 cell2 |
cell1 := cellMatrix at: rIndex at: cIndex.
cell2 := cellMatrix at: rIndex+1 at: cIndex.
cell1 placeHorizontalWallToSouthBetween: cell2.! !

!QMaze methodsFor: 'build' stamp: 'HwaJong 10/19/2012 17:01'!
placePlayerAtRowIndex: rIndex atColumnIndex: cIndex 
playerRowColumn := QCellRowColumn rowIndex: rIndex columnIndex: cIndex.! !

!QMaze methodsFor: 'build' stamp: 'HwaJong 10/19/2012 10:25'!
placeVerticalWallToEastAtRowIndex: rIndex atCellColumnIndex: cIndex 
| cell1 cell2 |
cell1 := cellMatrix at: rIndex at: cIndex.
cell2 := cellMatrix at: rIndex at: cIndex+1.
cell1 placeVerticalWallToEastBetween: cell2.! !

!QMaze methodsFor: 'testing' stamp: 'HwaJong 10/20/2012 19:29'!
playerCanGoEast
^self playerCell canGoEast! !

!QMaze methodsFor: 'testing' stamp: 'HwaJong 10/20/2012 19:29'!
playerCanGoNorth
^self playerCell canGoNorth! !

!QMaze methodsFor: 'testing' stamp: 'HwaJong 10/20/2012 19:28'!
playerCanGoSouth
^self playerCell canGoSouth! !

!QMaze methodsFor: 'testing' stamp: 'HwaJong 10/20/2012 19:28'!
playerCanGoWest
^self playerCell canGoWest! !

!QMaze methodsFor: 'accessing cell' stamp: 'HwaJong 10/19/2012 18:51'!
playerCell

	^playerRowColumn getFromMatrix: cellMatrix.! !

!QMaze methodsFor: 'testing' stamp: 'HwaJong 10/19/2012 18:42'!
playerIsAtGoal
^playerRowColumn = goalRowColumn ! !

!QMaze methodsFor: 'testing' stamp: 'HwaJong 10/19/2012 18:42'!
playerIsAtRow: anInteger atColumn: anInteger2 
^(QCellRowColumn rowIndex: anInteger columnIndex: anInteger2) = playerRowColumn.! !

!QMaze methodsFor: 'boundary cells' stamp: 'HwaJong 10/18/2012 21:50'!
rightCells
^cellMatrix atColumn: cellMatrix columnCount.! !

!QMaze methodsFor: 'boundary cells' stamp: 'HwaJong 10/18/2012 21:48'!
topCells
	^cellMatrix atRow: 1! !

Object subclass: #QuantumArray
	instanceVariableNames: 'array assertions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic'!

!QuantumArray class methodsFor: 'as yet unclassified' stamp: 'hjo 3/1/2012 09:30'!
new: anInteger

	^self new setSize: anInteger! !

!QuantumArray methodsFor: 'as yet unclassified' stamp: 'hjo 3/1/2012 11:29'!
array: anArray 

	array := anArray! !

!QuantumArray methodsFor: 'as yet unclassified' stamp: 'hjo 3/1/2012 11:21'!
assertions: anArray 

	assertions := anArray ! !

!QuantumArray methodsFor: 'as yet unclassified' stamp: 'hjo 3/1/2012 15:40'!
at: anInteger

	^array at: anInteger

	! !

!QuantumArray methodsFor: 'as yet unclassified' stamp: 'hjo 3/1/2012 09:41'!
at: anInteger be: anObject

	(array at: anInteger) be: anObject.

	! !

!QuantumArray methodsFor: 'as yet unclassified' stamp: 'hjo 3/1/2012 09:34'!
at: anInteger possibilities: anArray 

	array at: anInteger put: (QuantumObject possibilities: anArray)! !

!QuantumArray methodsFor: 'as yet unclassified' stamp: 'hjo 3/1/2012 15:40'!
at: anInteger put: aQuantumObject

	array at: anInteger put: aQuantumObject

	! !

!QuantumArray methodsFor: 'as yet unclassified' stamp: 'hjo 3/1/2012 11:32'!
determinedValue

	^array collect: #determinedValue! !

!QuantumArray methodsFor: 'as yet unclassified' stamp: 'hjo 3/1/2012 09:36'!
indexOfUndetermined

	array keysAndValuesDo: [:index :qo| qo isDetermined not ifTrue: [^index] ].
	^nil! !

!QuantumArray methodsFor: 'as yet unclassified' stamp: 'hjo 3/1/2012 09:39'!
isDetermined

	^array allSatisfy: [:each| each isDetermined ]  ! !

!QuantumArray methodsFor: 'as yet unclassified' stamp: 'hjo 3/1/2012 11:33'!
possibilities

	| index |
	self isDetermined ifTrue: [ ^Array with: self ].
	index := self indexOfUndetermined.
	^(array at: index) collectPossibilities: [:p| |qc| 
		qc := self quantumCopy at: index be: p. 
		qc isDetermined ifTrue: [ |dv| 
			dv := qc determinedValue.
			assertions do: [:block| (block value: dv) ifFalse: [OutOfQuantumPossibility new signal]] ].
		qc ]   ! !

!QuantumArray methodsFor: 'as yet unclassified' stamp: 'hjo 3/1/2012 09:49'!
printOn: aStream

	aStream nextPutAll: '#<'.
	array do: [:each| each printOn: aStream ] separatedBy: [aStream space].
	aStream nextPutAll: '>'.! !

!QuantumArray methodsFor: 'as yet unclassified' stamp: 'hjo 3/1/2012 11:29'!
quantumCopy

	^(self class new: array size) 
		array: array deepCopy;
		assertions: assertions.! !

!QuantumArray methodsFor: 'as yet unclassified' stamp: 'hjo 3/1/2012 09:31'!
setSize: anInteger 
	
	array := Array new: anInteger.! !

Object subclass: #QuantumBaseball
	instanceVariableNames: 'judge judgements quantumObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Example'!

!QuantumBaseball methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/2/2014 17:12'!
conclusion

	^quantumObject determinedValue ! !

!QuantumBaseball methodsFor: 'initialization' stamp: 'HwaJong 1/2/2014 03:17'!
initialize 

	super initialize.
	judgements := OrderedCollection new.
	quantumObject := QuantumObject possibilities: ((Permutations of: (1 to: 9) length: 4) asArray)! !

!QuantumBaseball methodsFor: 'testing' stamp: 'HwaJong 1/2/2014 03:17'!
isDetermined

	^quantumObject isDetermined! !

!QuantumBaseball methodsFor: 'accessing' stamp: 'hjo 2/16/2012 08:32'!
judge: aBaseBallJudge 

	judge := aBaseBallJudge! !

!QuantumBaseball methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/2/2014 16:58'!
makeAGuess

	judgements addLast: (judge judge: quantumObject possibilities anyOne).! !

!QuantumBaseball methodsFor: 'be' stamp: 'HwaJong 1/2/2014 19:38'!
meetsAllPreviousJudgementsForPossibility: anArray

	 | assumedJudge |
	assumedJudge := BaseBallJudge answer: anArray.
	^judgements 
		allSatisfy: [:each| assumedJudge verifyJudgement: each ]! !

!QuantumBaseball methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/2/2014 17:06'!
run
	[ self step ] whileTrue! !

!QuantumBaseball methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/2/2014 17:14'!
sizeOfPossibilities
	^quantumObject possibilities size  ! !

!QuantumBaseball methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/2/2014 17:20'!
step

	^quantumObject isDetermined
		ifTrue: [ false ]
		ifFalse: 
			[self makeAGuess.
			quantumObject selfSelectPossibilities: [:each| self meetsAllPreviousJudgementsForPossibility: each ].
			true ]
	! !

Object subclass: #QuantumMapColoring
	instanceVariableNames: 'alabama mississippi georgia tennessee florida'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Example'!

!QuantumMapColoring methodsFor: 'accessing' stamp: 'hjo 2/15/2012 22:19'!
alabama
	^ alabama! !

!QuantumMapColoring methodsFor: 'accessing' stamp: 'hjo 2/15/2012 22:19'!
alabama: anObject
	alabama := anObject! !

!QuantumMapColoring methodsFor: 'quantumlogic' stamp: 'HwaJong 1/2/2014 19:45'!
alabamaBe: aSymbol 

	self state: alabama colorSymbol: aSymbol neighboringStates: { mississippi . tennessee . georgia . florida }! !

!QuantumMapColoring methodsFor: 'accessing' stamp: 'hjo 2/15/2012 22:19'!
florida
	^ florida! !

!QuantumMapColoring methodsFor: 'accessing' stamp: 'hjo 2/15/2012 22:19'!
florida: anObject
	florida := anObject! !

!QuantumMapColoring methodsFor: 'accessing' stamp: 'hjo 2/15/2012 22:19'!
georgia
	^ georgia! !

!QuantumMapColoring methodsFor: 'accessing' stamp: 'hjo 2/15/2012 22:19'!
georgia: anObject
	georgia := anObject! !

!QuantumMapColoring methodsFor: 'quantumlogic' stamp: 'HwaJong 1/2/2014 19:45'!
georgiaBe: aSymbol 

	self state: georgia colorSymbol: aSymbol neighboringStates: {alabama  . tennessee . florida}! !

!QuantumMapColoring methodsFor: 'quantumlogic' stamp: 'hjo 2/15/2012 22:43'!
isDetermined

	^{alabama . mississippi . georgia . tennessee . florida} allSatisfy: [:each| each isDetermined ]  ! !

!QuantumMapColoring methodsFor: 'accessing' stamp: 'hjo 2/15/2012 22:19'!
mississippi
	^ mississippi! !

!QuantumMapColoring methodsFor: 'accessing' stamp: 'hjo 2/15/2012 22:19'!
mississippi: anObject
	mississippi := anObject! !

!QuantumMapColoring methodsFor: 'quantumlogic' stamp: 'HwaJong 1/2/2014 19:46'!
mississippiBe: aSymbol 

	self state: mississippi colorSymbol: aSymbol neighboringStates: {tennessee . alabama}! !

!QuantumMapColoring methodsFor: 'quantumlogic' stamp: 'hjo 2/15/2012 23:04'!
possibilities

	alabama isDetermined ifFalse: [ ^alabama collectPossibilities: [:each|
			self deepCopy alabamaBe: each]].
	mississippi isDetermined ifFalse: [ ^mississippi collectPossibilities: [:each|
			self deepCopy mississippiBe: each]].
	georgia isDetermined ifFalse: [ ^georgia collectPossibilities: [:each|
			self deepCopy georgiaBe: each]].! !

!QuantumMapColoring methodsFor: 'quantumlogic' stamp: 'HwaJong 1/2/2014 19:44'!
state: stateQ colorSymbol: aSymbol neighboringStates: anArray

	stateQ be: aSymbol.
	anArray do: [:qo| qo removePossibility: aSymbol  ].! !

!QuantumMapColoring methodsFor: 'accessing' stamp: 'hjo 2/15/2012 22:19'!
tennessee
	^ tennessee! !

!QuantumMapColoring methodsFor: 'accessing' stamp: 'hjo 2/15/2012 22:19'!
tennessee: anObject
	tennessee := anObject! !

Object subclass: #QuantumNonogram
	instanceVariableNames: 'matrix rows columns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Example'!

!QuantumNonogram class methodsFor: 'as yet unclassified' stamp: 'hjo 1/29/2012 22:09'!
rows: rowCount columns: columnCount 

	^self new
		matrix: (Matrix rows: rowCount columns: columnCount contents: (rowCount * columnCount timesCollect: [QuantumObject possibilities: {true. false}])).! !

!QuantumNonogram methodsFor: 'accessing' stamp: 'hjo 1/29/2012 21:19'!
columns

	^ columns isNil ifTrue: [columns := Array new: matrix columnCount ] ifFalse: [columns]! !

!QuantumNonogram methodsFor: 'initialize-release' stamp: 'hjo 2/1/2012 21:35'!
createColumnAt: anInteger withHint: anArray 

	self columns at: anInteger put: (QuantumNonogramArray cells: (matrix atColumn: anInteger) hints: anArray)! !

!QuantumNonogram methodsFor: 'initialize-release' stamp: 'hjo 2/1/2012 21:35'!
createRowAt: anInteger withHint: anArray 

	self rows at: anInteger put: (QuantumNonogramArray cells: (matrix atRow:anInteger) hints: anArray)! !

!QuantumNonogram methodsFor: 'running' stamp: 'hjo 2/1/2012 20:09'!
fillInTheCellIfCan

	self rows do: #fillInTheCellIfCan.
	self columns do: #fillInTheCellIfCan.! !

!QuantumNonogram methodsFor: 'testing' stamp: 'hjo 1/29/2012 21:31'!
isDetermined

	^matrix allSatisfy: [:each| each isDetermined ]  ! !

!QuantumNonogram methodsFor: 'accessing' stamp: 'hjo 1/29/2012 22:08'!
matrix: aMatrix 

	matrix := aMatrix! !

!QuantumNonogram methodsFor: 'printing' stamp: 'hjo 1/31/2012 00:07'!
printOn: aStream

	super printOn: aStream.
	matrix isNil
	ifFalse: [
	1 to: matrix rowCount do: [:r|			aStream cr.
		1 to: matrix columnCount do: [:c| |q|
			q := matrix at: r at: c.
			q isDetermined
				ifTrue: [q possibilities anyOne ifTrue: [aStream nextPut: $1] ifFalse: [aStream nextPut: $0]]
				ifFalse: [aStream nextPut: $* ].
			aStream space.
			].
		]]
		
! !

!QuantumNonogram methodsFor: 'changing' stamp: 'hjo 2/1/2012 20:47'!
putBool: aBoolean at: rowIndex at: columnIndex

	(matrix at: rowIndex at: columnIndex) be: aBoolean.! !

!QuantumNonogram methodsFor: 'accessing' stamp: 'hjo 1/29/2012 21:05'!
rows

	^ rows isNil ifTrue: [rows := Array new: matrix rowCount ] ifFalse: [rows]! !

!QuantumNonogram methodsFor: 'running' stamp: 'hjo 2/1/2012 20:42'!
runSolving

	[self isDetermined] whileFalse: [self stepSolving]  ! !

!QuantumNonogram methodsFor: 'running' stamp: 'hjo 2/1/2012 20:41'!
stepSolving

	self fillInTheCellIfCan! !

Object subclass: #QuantumNonogramArray
	instanceVariableNames: 'cells hints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Example'!

!QuantumNonogramArray class methodsFor: 'as yet unclassified' stamp: 'hjo 1/29/2012 21:05'!
cells: anArray hints: anArray2 

	^self new
		cells: anArray;
		hints: anArray2
		! !

!QuantumNonogramArray methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2012 19:19'!
cells

	^ cells! !

!QuantumNonogramArray methodsFor: 'as yet unclassified' stamp: 'hjo 1/29/2012 21:06'!
cells: anArray 

	cells := anArray! !

!QuantumNonogramArray methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2012 18:43'!
dupCopy

	^self species cells: cells deepCopy hints: hints! !

!QuantumNonogramArray methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2012 21:33'!
fillInTheCellIfCan
	
	|engine|
	self isDetermined ifTrue: [^self].
	engine := DepthFirstQuantumEngine new.
	engine stack push: self dupCopy.
	engine run.
			
	engine answers isEmpty ifTrue: [OutOfQuantumPossibility new signal].

	((1 to: cells size) collect: [:k|  QuantumObject fromQuantumObjects: engine answers gettingBlock: [:arr| arr cells at: k]  ]) 
		keysAndValuesDo: [:k :common | common isDetermined ifTrue: [self putBool: common determinedValue at: k] ].! !

!QuantumNonogramArray methodsFor: 'as yet unclassified' stamp: 'hjo 1/29/2012 22:20'!
hints

	^ hints! !

!QuantumNonogramArray methodsFor: 'as yet unclassified' stamp: 'hjo 1/29/2012 21:06'!
hints: anArray 

	hints := anArray! !

!QuantumNonogramArray methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2012 18:52'!
isDetermined

	^cells allSatisfy: [:qc| qc isDetermined ]  ! !

!QuantumNonogramArray methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2012 20:33'!
possibilities

	| indexOfUndetermined quantumToVary |
	quantumToVary := cells detect: [:each| each isDetermined not ] ifNone: [^{}].
	indexOfUndetermined := cells indexOf: quantumToVary.
	^(quantumToVary possibilities collect: [ :bool |
		[self dupCopy putBool: bool at: indexOfUndetermined] on: OutOfQuantumPossibility do: [:ex| nil].
		]) reject: [:each| each isNil ] ! !

!QuantumNonogramArray methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2012 18:54'!
printOn: aStream

	super printOn: aStream.
	cells notNil ifTrue: [
		aStream nextPut: $[.
		aStream print: cells.
		aStream nextPut: $]  
		]! !

!QuantumNonogramArray methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2012 19:47'!
putBool: aBoolean at: anInteger 

	(cells at: anInteger) be: aBoolean.
	self isDetermined 
			ifTrue: [ 
					((Array streamContents: [ :stream | 
									((cells collect: #determinedValue) as: RunArray) runsAndValuesDo: [ :r :v | v ifTrue: [ stream nextPut: r ] ] ]) = hints) ifFalse: [OutOfQuantumPossibility new signal] ]! !

Object subclass: #QuantumObject
	instanceVariableNames: 'possibilities'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic'!

!QuantumObject class methodsFor: 'instance creation' stamp: 'hjo 2/1/2012 21:33'!
fromQuantumObjects: anArray gettingBlock: aBlockClosure 

	^self unionPossibilitiesOfQuantumObjects: (anArray collect: [:qo| (aBlockClosure value: qo) ]).
	! !

!QuantumObject class methodsFor: 'instance creation' stamp: 'hjo 1/28/2012 17:54'!
possibilities: anArray 

	^self new possibilities: anArray  ! !

!QuantumObject class methodsFor: 'instance creation' stamp: 'hjo 2/1/2012 21:15'!
unionPossibilitiesOfQuantumObjects: aCollection
 
	^self possibilities: (aCollection inject: Set new into: [:set :qo| set addAll: qo possibilities; yourself]) asArray! !

!QuantumObject methodsFor: 'changing' stamp: 'hjo 2/1/2012 14:06'!
be: anObject 

	self assert: [possibilities includes: anObject].  
	possibilities := Array with: anObject! !

!QuantumObject methodsFor: 'as yet unclassified' stamp: 'hjo 2/15/2012 23:00'!
collectPossibilities: aBlockClosure 

	^Array streamContents: [:stream|
		possibilities do: [:each|  [stream nextPut: (aBlockClosure value: each)] on: OutOfQuantumPossibility do: [:exp| "ignore error"] ]
		].! !

!QuantumObject methodsFor: 'accessing' stamp: 'hjo 2/1/2012 18:24'!
determinedValue

	self assert: [self isDetermined].
	^possibilities anyOne! !

!QuantumObject methodsFor: 'testing' stamp: 'hjo 1/28/2012 17:55'!
isDetermined

	^possibilities size = 1! !

!QuantumObject methodsFor: 'accessing' stamp: 'hjo 1/28/2012 19:47'!
possibilities

	^ possibilities! !

!QuantumObject methodsFor: 'accessing' stamp: 'hjo 1/28/2012 20:42'!
possibilities: anArray 

	self assert: [anArray notEmpty].
	possibilities := anArray ! !

!QuantumObject methodsFor: 'printing' stamp: 'hjo 2/29/2012 23:39'!
printOn: aStream

	self isDetermined 
		ifTrue: [
			aStream nextPut: $[.
			aStream print: possibilities anyOne.
			aStream nextPut: $].   ]
		ifFalse: 
			[
			aStream nextPut:$[. 
			aStream print: possibilities size.
			aStream nextPutAll: ' possibilities'.  
			aStream nextPut: $] ]! !

!QuantumObject methodsFor: 'as yet unclassified' stamp: 'hjo 2/25/2012 10:00'!
quantumCopy

	^self class new possibilities: possibilities.  ! !

!QuantumObject methodsFor: 'changing' stamp: 'hjo 1/28/2012 20:18'!
removePossibility: anObject

	possibilities := possibilities copyWithout: anObject.
	possibilities isEmpty ifTrue: [OutOfQuantumPossibility new signal]! !

!QuantumObject methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/2/2014 17:19'!
selfSelectPossibilities: aBlockClosure 
	self possibilities: (self possibilities select: aBlockClosure)! !

Object subclass: #QuantumSudoku
	instanceVariableNames: 'matrix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Example'!

!QuantumSudoku class methodsFor: 'as yet unclassified' stamp: 'hjo 1/28/2012 19:35'!
matrix: aMatrix

	^self new matrix: aMatrix! !

!QuantumSudoku methodsFor: 'quantumlogic' stamp: 'hjo 1/29/2012 17:31'!
isDetermined

	^matrix allSatisfy: [:each| each isDetermined ]  ! !

!QuantumSudoku methodsFor: 'accessing' stamp: 'hjo 1/28/2012 19:35'!
matrix
	^matrix! !

!QuantumSudoku methodsFor: 'accessing' stamp: 'hjo 1/28/2012 19:35'!
matrix: aMatrix

	matrix := aMatrix! !

!QuantumSudoku methodsFor: 'accessing' stamp: 'hjo 1/28/2012 19:45'!
matrixIndexOfAmbiguousElement

	self matrix withIndicesDo: [:x :r :c| 
		x isDetermined ifFalse: [^{r. c}] ].
	^nil! !

!QuantumSudoku methodsFor: 'quantumlogic' stamp: 'hjo 1/29/2012 17:30'!
possibilities

	|ambiguousIndex|
	ambiguousIndex := self matrixIndexOfAmbiguousElement.
	^ambiguousIndex isNil 
		ifTrue: [ {} ]
		ifFalse: [
			((matrix at: ambiguousIndex first at: ambiguousIndex second) possibilities collect: [:p| |cop|
				cop := self deepCopy.
				[cop putNumber: p at: ambiguousIndex first at: ambiguousIndex second] on: OutOfQuantumPossibility do: [:exp| 
					cop := nil.
				].
				cop
				]) reject: [:each| each isNil].
		]! !

!QuantumSudoku methodsFor: 'printing' stamp: 'hjo 1/28/2012 20:23'!
printOn: aStream

	super printOn:   aStream.
	aStream nextPut: $[.
	aStream print: matrix.
	aStream nextPut: $].  ! !

!QuantumSudoku methodsFor: 'changing' stamp: 'hjo 1/28/2012 20:15'!
putNumber: aNumber at: rowIndex at: columnIndex

	| determinedQuantum blockR blockC cellsAffected|
	determinedQuantum := matrix at: rowIndex at: columnIndex.
	determinedQuantum be: aNumber.
	
	cellsAffected := ((matrix atRow: rowIndex), (matrix atColumn: columnIndex), 
		[blockR := ((rowIndex - 1)//3)*3+1.
		blockC := ((columnIndex -1)//3)*3+1.
		(matrix atRows: blockR to: blockR +2 columns: blockC to:  blockC + 2) asArray] value) copyWithout: determinedQuantum.
	cellsAffected do: [:each|
		each removePossibility: aNumber  
		]! !

Object subclass: #QuantumTape
	instanceVariableNames: 'sizeFixed innerArray defaultElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic'!

!QuantumTape methodsFor: 'as yet unclassified' stamp: 'hjo 2/25/2012 12:22'!
addLast

	^self at: innerArray size + 1! !

!QuantumTape methodsFor: 'as yet unclassified' stamp: 'hjo 2/25/2012 10:14'!
at: index

	self assert: [index >= 1].
	(sizeFixed and: [index > innerArray size]) ifTrue: [self errorSubscriptBounds: index ].
	[index > innerArray size] whileTrue: [
		innerArray addLast: defaultElement quantumCopy].
	^innerArray at: index! !

!QuantumTape methodsFor: 'as yet unclassified' stamp: 'hjo 2/25/2012 10:01'!
at: index be: value 

	^(self at: index) be: value.! !

!QuantumTape methodsFor: 'as yet unclassified' stamp: 'hjo 2/25/2012 09:57'!
defaultElement: aQuantumObject

	defaultElement := aQuantumObject! !

!QuantumTape methodsFor: 'as yet unclassified' stamp: 'hjo 2/25/2012 09:47'!
fixSize

	sizeFixed := true! !

!QuantumTape methodsFor: 'as yet unclassified' stamp: 'hjo 2/25/2012 09:48'!
initialize 

	super initialize.
	innerArray := OrderedCollection new.
	sizeFixed := false.! !

!QuantumTape methodsFor: 'as yet unclassified' stamp: 'hjo 2/25/2012 10:41'!
printOn: aStream

	aStream nextPut: $(.  
	innerArray do: [:each| 
		each isDetermined ifTrue: [each determinedValue printOn:aStream] ifFalse: [ aStream nextPut: $?]. 
		aStream space ].
	(sizeFixed and: [innerArray notEmpty]) ifTrue: [aStream skip: -1].
	sizeFixed ifFalse: [aStream nextPut: $*].
	aStream nextPut: $).  
	! !

!QuantumTape methodsFor: 'as yet unclassified' stamp: 'hjo 2/25/2012 09:48'!
size

	^sizeFixed ifTrue: [innerArray size] ifFalse: [#undeterminedSize].! !

Object subclass: #QuantumZebra
	instanceVariableNames: 'houses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Example'!

!QuantumZebra methodsFor: 'as yet unclassified' stamp: 'hjo 2/29/2012 22:07'!
isDetermined

	^houses allSatisfy: [:each| each isDetermined ]  ! !

!QuantumZebra methodsFor: 'as yet unclassified' stamp: 'hjo 2/29/2012 22:11'!
possibilities

	self isDetermined ifTrue: [^Array with: self].
	
	1 to: houses size do: [:k| |h|
		h := houses at: k.
		h isDetermined ifFalse: [ ^h collectPossibilities: [:p| self quantumCopy houseAt:k be: p ]  ]
		].! !

Object subclass: #QuantumZebraHouse
	instanceVariableNames: 'mansNationality pet smoke color drink'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuantumLogic-Example'!

!QuantumZebraHouse class methodsFor: 'as yet unclassified' stamp: 'hjo 2/29/2012 22:12'!
puzzle

	^self new setUpPuzzle.! !

!QuantumZebraHouse methodsFor: 'as yet unclassified' stamp: 'hjo 2/29/2012 22:02'!
isDetermined 

	^{mansNationality. pet. smoke. color. drink} allSatisfy: [:each| each isDetermined ]  ! !

!QuantumZebraHouse methodsFor: 'as yet unclassified' stamp: 'hjo 3/1/2012 09:11'!
possibilities

	| key |
	key := self undeterminedKey.
	key halt.
	^{}! !

!QuantumZebraHouse methodsFor: 'as yet unclassified' stamp: 'hjo 2/29/2012 22:16'!
setUpPuzzle

	mansNationality := QuantumObject possibilities: #(japanese spaniard norwegian english ukrainian).  
	pet := QuantumObject possibilities: #(dog snails).
	smoke := QuantumObject possibilities: #(oldGold  kool  parliaments luckyStrike).
	color := QuantumObject possibilities: #(red green ivory blue yellow).
	drink := QuantumObject possibilities: #(tea coffee milk orangeJuice.).! !

!QuantumZebraHouse methodsFor: 'as yet unclassified' stamp: 'hjo 3/1/2012 09:10'!
undeterminedKey

	mansNationality isDetermined ifFalse: [^#mansNationality].
	pet isDetermined ifFalse: [^#pet].
	smoke isDetermined ifFalse: [^#smoke].
	color isDetermined ifFalse: [^#color].
	drink isDetermined ifFalse: [^#drink].
	^nil! !
